///home/berryj/link/bin/genMethods "-g" "-t" "MUBinGraph*" "-r" "MBinGraph*" "-I" "LINK/graph/UBinGraph.h" "-y" "display_graphptr" "-m" "mark_graphptr" "-w" "free_graphptr" "-d" "graph" "-f" "__mUBinGraph_" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/UBinGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graphptr(SCM, SCM, int);
void mark_graphptr(SCM);
void free_graphptr(SCM);

typedef MUBinGraph* _MUBinGraph_;

#define _MUBinGraph_DATA(x) ((MUBinGraph**) (EXTDATA(x)))
#define _MUBinGraph_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MUBinGraph* >::type))
#define _MUBinGraph_ISNT_DATA(x) (!_MUBinGraph_IS_DATA(x))

#define _MUBinGraph_CXX_DATA(x) (*(MUBinGraph**) (EXTDATA(VAL(x))))
#define _MUBinGraph_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MUBinGraph* >::type))
#define _MUBinGraph_CXX_ISNT_DATA(x) (!_MUBinGraph_CXX_IS_DATA(x))


static SCM is_MUBinGraph_(SCM i)
{
	if (_MUBinGraph_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init___mUBinGraph_()
{
	Wrapper<_MUBinGraph_>::type = STk_new_CXXwrapper_id(
			Wrapper<_MUBinGraph_>::name, 
			Wrapper<MBinGraph* >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graphptr,
			(void (*)(SCM x))mark_graphptr,
			(void (*)(SCM x))free_graphptr);
	Tcl_InitHashTable(&Register<_MUBinGraph_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("MUBinGraph?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_MUBinGraph_);
	return UNDEFINED;
}

void genExtra__mUBinGraph_Methods(void);

PRIMITIVE STk_init_methods___mUBinGraph_()
{
	genExtra__mUBinGraph_Methods();
	return UNDEFINED;
}
